/*
 * 
 *  dynamic linker command file
 *  generated: Sat May 04 14:33:43 2002

 *  kernel   : legOS
 *  app start: 0xa7d6
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x27d6
  ram   : o = 0xa7d6, l = 0x5726
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d0 ;
    _mm_update_first_free = 0x0100 ;
    _mm_init = 0x0122 ;
    _malloc = 0x01a8 ;
    _free = 0x024c ;
    _calloc = 0x0276 ;
    _mm_reaper = 0x029e ;
    _systime_handler = 0x030a ;
    _systime_tm_return = 0x0392 ;
    _systime_init = 0x03a2 ;
    _systime_shutdown = 0x03ec ;
    _systime_set_switcher = 0x03f4 ;
    _systime_set_timeslice = 0x03fa ;
    _tm_switcher = 0x0410 ;
    _tm_scheduler = 0x042c ;
    _yield = 0x0620 ;
    _tm_init = 0x063e ;
    _tm_start = 0x0680 ;
    _execi = 0x0690 ;
    _exit = 0x081a ;
    _wait_event = 0x0830 ;
    _msleep = 0x089c ;
    _sleep = 0x08be ;
    _kill = 0x08dc ;
    _killall = 0x0918 ;
    _sem_event_wait = 0x0986 ;
    _sem_wait = 0x099e ;
    _sem_trywait = 0x09be ;
    _sem_post = 0x09d6 ;
    _delay = 0x09e6 ;
    _cputc_native = 0x0a00 ;
    _cputc_native_0 = 0x0a32 ;
    _cputc_native_1 = 0x0a6a ;
    _cputc_native_2 = 0x0aa2 ;
    _cputc_native_3 = 0x0ade ;
    _cputc_native_4 = 0x0b1a ;
    _cputc_native_5 = 0x0b56 ;
    _cputw = 0x0b62 ;
    _cputs = 0x0ba6 ;
    _cls = 0x0bee ;
    _lcd_number = 0x0bf8 ;
    _lcd_refresh_next_byte = 0x0c8a ;
    _lcd_refresh_next_byte_core = 0x0c9e ;
    _lcd_refresh = 0x0cf2 ;
    _lcd_power_on = 0x0d22 ;
    _lcd_power_off = 0x0d34 ;
    _lcd_init = 0x0d50 ;
    _Emachine = 0x0d98 ;
    _trigger_queue_init = 0x10d4 ;
    _write_int = 0x10da ;
    _read_int = 0x10e6 ;
    _button_pressed = 0x10f2 ;
    _button_event_trigger = 0x1128 ;
    _time_trigger = 0x116c ;
    _itoa = 0x11b8 ;
    _insertChar = 0x1228 ;
    _rx_handler = 0x123e ;
    _rx_core = 0x1252 ;
    _rxerror_handler = 0x12c8 ;
    _rxerror_core = 0x12dc ;
    _txend_handler = 0x1326 ;
    _txend_core = 0x133a ;
    _tx_handler = 0x1348 ;
    _tx_core = 0x135c ;
    _lnp_logical_shutdown = 0x1384 ;
    _lnp_logical_init = 0x13a4 ;
    _lnp_logical_write = 0x1452 ;
    _lnp_integrity_write = 0x14fe ;
    _lnp_addressing_write = 0x1556 ;
    _lnp_receive_packet = 0x15d0 ;
    _lnp_integrity_byte = 0x1616 ;
    _lnp_integrity_reset = 0x16d4 ;
    _lnp_integrity_reset_core = 0x16e8 ;
    _lnp_timeout_reset = 0x1714 ;
    _lnp_timeout_reset_core = 0x1728 ;
    _lnp_init = 0x1732 ;
    _lnp_integrity_active = 0x1752 ;
    _lnp_timeout_set = 0x175e ;
    _program_valid = 0x1768 ;
    _key_handler = 0x1aac ;
    _program_init = 0x1bac ;
    _program_shutdown = 0x1bf2 ;
    _vis_handler = 0x1bfc ;
    _vis_core = 0x1c10 ;
    _get_battery_mv = 0x1c64 ;
    _battery_refresh = 0x1c92 ;
    _battery_refresh_core = 0x1ca6 ;
    _dkey_handler = 0x1cd0 ;
    _dkey_pressed = 0x1d0e ;
    _dkey_released = 0x1d1c ;
    _getchar = 0x1d3c ;
    _dm_handler = 0x1d62 ;
    _dm_init = 0x1da0 ;
    _dm_shutdown = 0x1da4 ;
    _ds_rotation_set = 0x1dd2 ;
    _ds_rotation_handler = 0x1e2a ;
    _ds_init = 0x1f1a ;
    _ds_shutdown = 0x1f50 ;
    _dsound_handler = 0x1f6a ;
    _dsound_core = 0x1f7e ;
    _dsound_init = 0x2078 ;
    _dsound_shutdown = 0x2090 ;
    _dsound_stop = 0x2094 ;
    _dsound_finished = 0x20b4 ;
    _memset = 0x20ce ;
    _memcpy = 0x20dc ;
    ___mulhi3 = 0x20ee ;
    ___modhi3 = 0x20fe ;
    ___divhi3 = 0x2110 ;
    ___mulsi3 = 0x2122 ;
    ___divsi3 = 0x213e ;
    _hex_display_codes = 0x217c ;
    _ascii_display_codes = 0x218c ;
    _min_length = 0x222c ;
    _dm_a_pattern = 0x223e ;
    _dm_b_pattern = 0x2242 ;
    _dm_c_pattern = 0x2246 ;
    _firmware_string = 0x2328 ;
    _etext = 0x2328 ;
    _lcd_refresh_period = 0x232c ;
    _lnp_timeout = 0x232e ;
    _vis_refresh_counter = 0x2330 ;
    _vis_refresh_period = 0x2331 ;
    _battery_refresh_counter = 0x2332 ;
    _battery_refresh_period = 0x2334 ;
    _dsound_system_sounds = 0x2336 ;
    __edata = 0x2338 ;
    _bss_start = 0x2340 ;
    _mm_semaphore = 0x2728 ;
    _mm_first_free = 0x272a ;
    _tm_timeslice = 0x272c ;
    _tm_current_slice = 0x272d ;
    _tm_switcher_vector = 0x272e ;
    _sys_time = 0x2730 ;
    _pd_idle = 0x2740 ;
    _cpid = 0x2742 ;
    _nb_tasks = 0x2744 ;
    _priority_head = 0x2746 ;
    _pd_single = 0x2750 ;
    _task_sem = 0x2764 ;
    _lcd_byte_counter = 0x2766 ;
    _lcd_refresh_counter = 0x2767 ;
    _tx_state = 0x2768 ;
    _tx_sem = 0x2769 ;
    _lnp_integrity_handler = 0x2770 ;
    _lnp_timeout_counter = 0x2772 ;
    _lnp_addressing_handler = 0x2780 ;
    _lnp_integrity_state = 0x27a0 ;
    _packet_len = 0x27a2 ;
    _cprog = 0x27a4 ;
    _packet_src = 0x27a6 ;
    _dkey_timer = 0x27a8 ;
    _dkey = 0x27a9 ;
    _dkey_multi = 0x27aa ;
    _dm_a = 0x27ac ;
    _dm_b = 0x27b0 ;
    _dm_c = 0x27b4 ;
    _ds_rotation = 0x27b8 ;
    _ds_channel = 0x27b9 ;
    _ds_rotations = 0x27c0 ;
    _ds_activation = 0x27c6 ;
    _dsound_next_note = 0x27c8 ;
    _dsound_internote_ms = 0x27ca ;
    _dsound_16th_ms = 0x27cc ;
    _dsound_next_time = 0x27d0 ;
    _end = 0x27d4 ;
    _mm_start = 0x27d4 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
